Code

Documentation: For consistency, use CVS instead of cvs.
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6   [--interactive] [--whitespace=<option>] [-C<n>] [-p<n>] <mbox>...
7   or, when resuming [--skip | --resolved]'
8 . git-sh-setup
9 set_reflog_action am
10 require_work_tree
12 git var GIT_COMMITTER_IDENT >/dev/null || exit
14 stop_here () {
15     echo "$1" >"$dotest/next"
16     exit 1
17 }
19 stop_here_user_resolve () {
20     if [ -n "$resolvemsg" ]; then
21             printf '%s\n' "$resolvemsg"
22             stop_here $1
23     fi
24     cmdline=$(basename $0)
25     if test '' != "$interactive"
26     then
27         cmdline="$cmdline -i"
28     fi
29     if test '' != "$threeway"
30     then
31         cmdline="$cmdline -3"
32     fi
33     if test '.dotest' != "$dotest"
34     then
35         cmdline="$cmdline -d=$dotest"
36     fi
37     echo "When you have resolved this problem run \"$cmdline --resolved\"."
38     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
40     stop_here $1
41 }
43 go_next () {
44         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45                 "$dotest/patch" "$dotest/info"
46         echo "$next" >"$dotest/next"
47         this=$next
48 }
50 cannot_fallback () {
51         echo "$1"
52         echo "Cannot fall back to three-way merge."
53         exit 1
54 }
56 fall_back_3way () {
57     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
59     rm -fr "$dotest"/patch-merge-*
60     mkdir "$dotest/patch-merge-tmp-dir"
62     # First see if the patch records the index info that we can use.
63     git apply -z --index-info "$dotest/patch" \
64         >"$dotest/patch-merge-index-info" &&
65     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66     git update-index -z --index-info <"$dotest/patch-merge-index-info" &&
67     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68     git write-tree >"$dotest/patch-merge-base+" ||
69     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
71     echo Using index info to reconstruct a base tree...
72     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73         git apply $binary --cached <"$dotest/patch"
74     then
75         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
77     else
78         cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
80     fi
82     test -f "$dotest/patch-merge-index" &&
83     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
84     orig_tree=$(cat "$dotest/patch-merge-base") &&
85     rm -fr "$dotest"/patch-merge-* || exit 1
87     echo Falling back to patching base and 3-way merge...
89     # This is not so wrong.  Depending on which base we picked,
90     # orig_tree may be wildly different from ours, but his_tree
91     # has the same set of wildly different changes in parts the
92     # patch did not touch, so recursive ends up canceling them,
93     # saying that we reverted all those changes.
95     eval GITHEAD_$his_tree='"$SUBJECT"'
96     export GITHEAD_$his_tree
97     git-merge-recursive $orig_tree -- HEAD $his_tree || {
98             git rerere
99             echo Failed to merge in the changes.
100             exit 1
101     }
102     unset GITHEAD_$his_tree
105 prec=4
106 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
107 resolvemsg= resume=
108 git_apply_opt=
110 while case "$#" in 0) break;; esac
111 do
112         case "$1" in
113         -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
114         dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
115         -d|--d|--do|--dot|--dote|--dotes|--dotest)
116         case "$#" in 1) usage ;; esac; shift
117         dotest="$1"; shift;;
119         -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
120         --interacti|--interactiv|--interactive)
121         interactive=t; shift ;;
123         -b|--b|--bi|--bin|--bina|--binar|--binary)
124         binary=t; shift ;;
126         -3|--3|--3w|--3wa|--3way)
127         threeway=t; shift ;;
128         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
129         sign=t; shift ;;
130         -u|--u|--ut|--utf|--utf8)
131         utf8=t; shift ;; # this is now default
132         --no-u|--no-ut|--no-utf|--no-utf8)
133         utf8=; shift ;;
134         -k|--k|--ke|--kee|--keep)
135         keep=t; shift ;;
137         -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
138         resolved=t; shift ;;
140         --sk|--ski|--skip)
141         skip=t; shift ;;
143         --whitespace=*|-C*|-p*)
144         git_apply_opt="$git_apply_opt $1"; shift ;;
146         --resolvemsg=*)
147         resolvemsg=${1#--resolvemsg=}; shift ;;
149         --)
150         shift; break ;;
151         -*)
152         usage ;;
153         *)
154         break ;;
155         esac
156 done
158 # If the dotest directory exists, but we have finished applying all the
159 # patches in them, clear it out.
160 if test -d "$dotest" &&
161    last=$(cat "$dotest/last") &&
162    next=$(cat "$dotest/next") &&
163    test $# != 0 &&
164    test "$next" -gt "$last"
165 then
166    rm -fr "$dotest"
167 fi
169 if test -d "$dotest"
170 then
171         case "$#,$skip$resolved" in
172         0,*t*)
173                 # Explicit resume command and we do not have file, so
174                 # we are happy.
175                 : ;;
176         0,)
177                 # No file input but without resume parameters; catch
178                 # user error to feed us a patch from standard input
179                 # when there is already .dotest.  This is somewhat
180                 # unreliable -- stdin could be /dev/null for example
181                 # and the caller did not intend to feed us a patch but
182                 # wanted to continue unattended.
183                 tty -s
184                 ;;
185         *)
186                 false
187                 ;;
188         esac ||
189         die "previous dotest directory $dotest still exists but mbox given."
190         resume=yes
191 else
192         # Make sure we are not given --skip nor --resolved
193         test ",$skip,$resolved," = ,,, ||
194                 die "Resolve operation not in progress, we are not resuming."
196         # Start afresh.
197         mkdir -p "$dotest" || exit
199         git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
200                 rm -fr "$dotest"
201                 exit 1
202         }
204         # -b, -s, -u, -k and --whitespace flags are kept for the
205         # resuming session after a patch failure.
206         # -3 and -i can and must be given when resuming.
207         echo "$binary" >"$dotest/binary"
208         echo " $ws" >"$dotest/whitespace"
209         echo "$sign" >"$dotest/sign"
210         echo "$utf8" >"$dotest/utf8"
211         echo "$keep" >"$dotest/keep"
212         echo 1 >"$dotest/next"
213 fi
215 case "$resolved" in
216 '')
217         files=$(git diff-index --cached --name-only HEAD) || exit
218         if [ "$files" ]; then
219            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
220            exit 1
221         fi
222 esac
224 if test "$(cat "$dotest/binary")" = t
225 then
226         binary=--allow-binary-replacement
227 fi
228 if test "$(cat "$dotest/utf8")" = t
229 then
230         utf8=-u
231 else
232         utf8=-n
233 fi
234 if test "$(cat "$dotest/keep")" = t
235 then
236         keep=-k
237 fi
238 ws=`cat "$dotest/whitespace"`
239 if test "$(cat "$dotest/sign")" = t
240 then
241         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
242                         s/>.*/>/
243                         s/^/Signed-off-by: /'
244                 `
245 else
246         SIGNOFF=
247 fi
249 last=`cat "$dotest/last"`
250 this=`cat "$dotest/next"`
251 if test "$skip" = t
252 then
253         git rerere clear
254         this=`expr "$this" + 1`
255         resume=
256 fi
258 if test "$this" -gt "$last"
259 then
260         echo Nothing to do.
261         rm -fr "$dotest"
262         exit
263 fi
265 while test "$this" -le "$last"
266 do
267         msgnum=`printf "%0${prec}d" $this`
268         next=`expr "$this" + 1`
269         test -f "$dotest/$msgnum" || {
270                 resume=
271                 go_next
272                 continue
273         }
275         # If we are not resuming, parse and extract the patch information
276         # into separate files:
277         #  - info records the authorship and title
278         #  - msg is the rest of commit log message
279         #  - patch is the patch body.
280         #
281         # When we are resuming, these files are either already prepared
282         # by the user, or the user can tell us to do so by --resolved flag.
283         case "$resume" in
284         '')
285                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
286                         <"$dotest/$msgnum" >"$dotest/info" ||
287                         stop_here $this
289                 # skip pine's internal folder data
290                 grep '^Author: Mail System Internal Data$' \
291                         <"$dotest"/info >/dev/null &&
292                         go_next && continue
294                 test -s $dotest/patch || {
295                         echo "Patch is empty.  Was it split wrong?"
296                         stop_here $this
297                 }
298                 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
299                 ;;
300         esac
302         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
303         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
304         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
306         if test -z "$GIT_AUTHOR_EMAIL"
307         then
308                 echo "Patch does not have a valid e-mail address."
309                 stop_here $this
310         fi
312         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
314         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
315         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
317         case "$resume" in
318         '')
319             if test '' != "$SIGNOFF"
320             then
321                 LAST_SIGNED_OFF_BY=`
322                     sed -ne '/^Signed-off-by: /p' \
323                     "$dotest/msg-clean" |
324                     tail -n 1
325                 `
326                 ADD_SIGNOFF=`
327                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
328                     test '' = "$LAST_SIGNED_OFF_BY" && echo
329                     echo "$SIGNOFF"
330                 }`
331             else
332                 ADD_SIGNOFF=
333             fi
334             {
335                 printf '%s\n' "$SUBJECT"
336                 if test -s "$dotest/msg-clean"
337                 then
338                         echo
339                         cat "$dotest/msg-clean"
340                 fi
341                 if test '' != "$ADD_SIGNOFF"
342                 then
343                         echo "$ADD_SIGNOFF"
344                 fi
345             } >"$dotest/final-commit"
346             ;;
347         *)
348                 case "$resolved$interactive" in
349                 tt)
350                         # This is used only for interactive view option.
351                         git diff-index -p --cached HEAD >"$dotest/patch"
352                         ;;
353                 esac
354         esac
356         resume=
357         if test "$interactive" = t
358         then
359             test -t 0 ||
360             die "cannot be interactive without stdin connected to a terminal."
361             action=again
362             while test "$action" = again
363             do
364                 echo "Commit Body is:"
365                 echo "--------------------------"
366                 cat "$dotest/final-commit"
367                 echo "--------------------------"
368                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
369                 read reply
370                 case "$reply" in
371                 [yY]*) action=yes ;;
372                 [aA]*) action=yes interactive= ;;
373                 [nN]*) action=skip ;;
374                 [eE]*) git_editor "$dotest/final-commit"
375                        action=again ;;
376                 [vV]*) action=again
377                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
378                 *)     action=again ;;
379                 esac
380             done
381         else
382             action=yes
383         fi
385         if test $action = skip
386         then
387                 go_next
388                 continue
389         fi
391         if test -x "$GIT_DIR"/hooks/applypatch-msg
392         then
393                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
394                 stop_here $this
395         fi
397         echo
398         printf 'Applying %s\n' "$SUBJECT"
399         echo
401         case "$resolved" in
402         '')
403                 git apply $git_apply_opt $binary --index "$dotest/patch"
404                 apply_status=$?
405                 ;;
406         t)
407                 # Resolved means the user did all the hard work, and
408                 # we do not have to do any patch application.  Just
409                 # trust what the user has in the index file and the
410                 # working tree.
411                 resolved=
412                 git diff-index --quiet --cached HEAD && {
413                         echo "No changes - did you forget to use 'git add'?"
414                         stop_here_user_resolve $this
415                 }
416                 unmerged=$(git ls-files -u)
417                 if test -n "$unmerged"
418                 then
419                         echo "You still have unmerged paths in your index"
420                         echo "did you forget to use 'git add'?"
421                         stop_here_user_resolve $this
422                 fi
423                 apply_status=0
424                 git rerere
425                 ;;
426         esac
428         if test $apply_status = 1 && test "$threeway" = t
429         then
430                 if (fall_back_3way)
431                 then
432                     # Applying the patch to an earlier tree and merging the
433                     # result may have produced the same tree as ours.
434                     git diff-index --quiet --cached HEAD && {
435                         echo No changes -- Patch already applied.
436                         go_next
437                         continue
438                     }
439                     # clear apply_status -- we have successfully merged.
440                     apply_status=0
441                 fi
442         fi
443         if test $apply_status != 0
444         then
445                 echo Patch failed at $msgnum.
446                 stop_here_user_resolve $this
447         fi
449         if test -x "$GIT_DIR"/hooks/pre-applypatch
450         then
451                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
452         fi
454         tree=$(git write-tree) &&
455         echo Wrote tree $tree &&
456         parent=$(git rev-parse --verify HEAD) &&
457         commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
458         echo Committed: $commit &&
459         git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
460         stop_here $this
462         if test -x "$GIT_DIR"/hooks/post-applypatch
463         then
464                 "$GIT_DIR"/hooks/post-applypatch
465         fi
467         go_next
468 done
470 rm -fr "$dotest"